package com.plutext.samples.mergedocx;

import org.docx4j.Docx4J;
import org.docx4j.openpackaging.exceptions.Docx4JException;
import org.docx4j.openpackaging.packages.Filetype;
import org.docx4j.openpackaging.packages.OpcPackage;
import org.docx4j.openpackaging.packages.WordprocessingMLPackage;

import com.plutext.merge.TrimResources;

/**
 *  In cases where documents containing very many numbering definitions
 *  are merged, this can run into resource limitations in Word.
 *  
 *  To address this, TrimResources removes unused numbering from an output docx.  
 *
 */
public class RemoveUnusedNumbering {

	public static void main(String[] args) throws Docx4JException {
		
		WordprocessingMLPackage opcPackage = (WordprocessingMLPackage)OpcPackage.load(
				new java.io.File(
						System.getProperty("user.dir")+ "/OUT_MergeWholeDocumentsIncremental.docx"), Filetype.ZippedPackage);
		
		TrimResources trimmer = new TrimResources();
		trimmer.trim(opcPackage);
		
		System.out.println(opcPackage.getMainDocumentPart().getNumberingDefinitionsPart().getXML());
		
		Docx4J.save(opcPackage, new java.io.File(
						System.getProperty("user.dir")+ "/OUT_MergeWholeDocumentsIncremental_reduced.docx"));
	}
	
}
